banner = "Codabar message conversion"
msgtext = "Enter message to be converted."

dim chars
dim val(255)

for i = 0 to 255
    val(i) = -1
next
for i = 0 to 9
    val(i + 48) = i
next
val(45) = 10
val(36) = 11
val(58) = 12
val(47) = 13
val(46) = 14
val(43) = 15
val(65) = 16
val(66) = 17
val(67) = 18
val(68) = 19

valid = false
message = ""
prev = ""
l = 1
while l > 0
    message = getmsg
    if message > "" then
        convmess = convert
        message = inputbox("Copy the text below, and paste it into your" _
            & " application." & vbNewLine & vbNewLine _
            & "You may then enter a new message for another conversion.", _
            banner, convmess)
        valid = false
        l = len(message)
    end if
wend

function getmsg
    while not valid
        if message = "" then
            message = inputbox(msgtext, banner, prev)
        end if
        chars = mysplit(message)
        l = len(message)
        if l > 0 then
            if asc(chars(1)) < 65 or asc(chars(1)) > 68 _
                or asc(chars(l)) < 65 or asc(chars(l)) > 68 then
                MsgBox "Message must begin and end with one of the" _
                   & " characters A, B, C or D." & char, vbCritical, "Error"
                prev = message
                message = ""
            else
                valid = true
                for i = 2 to l-1
                    if val(asc(chars(i))) < 0 or val(asc(chars(i))) > 15 then
                        valid = false
                        char = chars(i)
                        exit for
                    end if
                next
                if not valid then
                    MsgBox "Invalid character: " & char, vbCritical, "Error"
                    prev = message
                    message = ""
                end if
            end if
        else
            valid = true
        end if
    wend
    getmsg = message
end function

function convert
    check = 0
    for i = 1 to l
        check = check + val(asc(chars(i)))
    next
    check = 16 - check mod 16
    if check = 16 then check = 0
    ch = chars(l)
    for i = 0 to 255
        if check = val(i) then
            chars(l) = chr(i)
        end if
    next
    convert = join(chars, "") & ch
end function

function mysplit(text)
    dim myarray()
    redim myarray(len(text))
    for i = 1 to len(text)
        myarray(i) = mid(text, i, 1)
    next
    mysplit = myarray
end function
