banner = "Code 128 message conversion"
msgtext = "Enter message to be converted."

dim chars
dim chrs

valid = false
message = ""
prev = ""
l = 1
while l > 0
    message = getmsg
    if message > "" then
        convmess = convert
        message = inputbox("Copy the text below, and paste it into your" _
            & " application." & vbNewLine & vbNewLine _
            & "You may then enter a new message for another conversion.", _
            banner, convmess)
        valid = false
        l = len(message)
    end if
wend

function getmsg
    while not valid
        if message = "" then
            message = inputbox(msgtext, banner, prev)
        end if
        chars = mysplit(message)
        l = len(message)
        if l > 0 then
            valid = true
            for i = 1 to l
                if asc(chars(i)) > 127 then
                    valid = false
                    char = chars(i)
                    exit for
                end if
            next
            if not valid then
                MsgBox "Invalid character: " & char, vbCritical, "Error"
                prev = message
                message = ""
            end if
        else
            valid = true
        end if
    wend
    getmsg = message
end function

function convert
    redim chrs(l+1)
    temp = chars
    start = 104
    mode = 0
    m = 1
    for i = 1 to l + 1
        sw = true
        if i < l + 1 then
            digit = asc(temp(i)) > 47 and asc(temp(i)) < 58
            if (mode = 0 and not digit) or (mode = 1 and digit) then sw = false
        end if
        if mode = 0 then
            if sw then
                ind = i
                mode = 1
            else
                chrs(m) = asc(temp(i)) - 32
                m = m + 1
            end if
        elseif sw then
            if i - ind < 4 then
                for j = 0 to i - ind - 1
                    chrs(m+j) = asc(temp(ind+j)) - 32
                next
                m = m + i - ind
                if i < l + 1 then
                    chrs(m) = asc(temp(i)) - 32
                    m = m + 1
                end if
            else
                if ind = 1 then
                    start = 105
                else
                    chrs(m) = 99
                    m = m + 1
                end if
                n = int((i - ind)/2)
                for j = 0 to n - 1
                    chrs(m+j) = 10*temp(ind+2*j) + temp(ind+2*j+1)
                next
                m = m + n
                if i < l + 1 then
                    chrs(m) = 100
                    m = m + 1
                end if
                if (i - ind) mod 2 = 1 then
                    chrs(m) = asc(temp(i-1)) - 32
                    m = m + 1
                end if
                if i < l + 1 then
                    chrs(m) = asc(temp(i)) - 32
                    m = m + 1
                end if
            end if
            mode = 0
        end if
    next
    check = start
    for i = 1 to m - 1
        check = check + chrs(i)*i
    next
    ch = chr((check mod 103) + 32)
    chrs(m) = check mod 103
    for i = 1 to m
        if chrs(i) < 96 then
            chrs(i) = chr(chrs(i) + 32)
        else
            chrs(i) = chr(chrs(i) + 97)
        end if
    next
    convert = chr(start+97) & join(chrs, "") & chr(203)
end function

function mysplit(text)
    dim myarray()
    redim myarray(len(text))
    for i = 1 to len(text)
        myarray(i) = mid(text, i, 1)
    next
    mysplit = myarray
end function
