banner = "Interleaved 2 of 5 message conversion"
msgtext = "Enter message to be converted."

dim chars

valid = false
message = ""
prev = ""
l = 1
while l > 0
    message = getmsg
    if message > "" then
        convmess = convert
        if convmess <> "" then
            message = inputbox("Copy the text below, and paste it into your" _
                & " application." & vbNewLine & vbNewLine _
                & "You may then enter a new message for another conversion.", _
                banner, convmess)
            valid = false
            l = len(message)
        else
            l = 0
        end if
    end if
wend

function getmsg
    while not valid
        if message = "" then
            message = inputbox(msgtext, banner, prev)
        end if
        chars = mysplit(message)
        l = len(message)
        if l > 0 then
            valid = true
            for i = 1 to l
                if asc(chars(i)) < 48 or asc(chars(i)) > 57 then
                    valid = false
                    char = chars(i)
                    exit for
                end if
            next
            if not valid then
                msgbox "Invalid character: " & char, vbCritical, "Error"
                prev = message
                message = ""
            end if
        else
            valid = true
        end if
    wend
    getmsg = message
end function

function convert
    if msgbox("Should the optional check character be added to the message?", _
              vbQuestion + vbYesNo, banner) = vbYes then
        check = 0
        for i = 1 to l
            check = check + (asc(chars(i))-48)*(1 + 2*((i+l+1) mod 2))
        next
        check = 10 - check mod 10
        if check = 10 then check = 0
        message = message & chr(check+48)
    end if
    if len(message) mod 2 = 1 then message = "0" & message
    chars = mysplit(message)
    text = ""
    for i = 1 to len(message)/2
        val = 10*chars(2*i-1) + chars(2*i)
        if val < 95 then
            text = text & chr(val+32)
        else
            text = text & chr(val+97)
        end if
    next
    convert = chr(197) & text & chr(198)
end function

function mysplit(text)
    dim myarray()
    redim myarray(len(text))
    for i = 1 to len(text)
        myarray(i) = mid(text, i, 1)
    next
    mysplit = myarray
end function
