banner = "Code 39 message conversion"
msgtext = "Enter message to be converted."

dim chars
dim val(255)

for i = 0 to 255
    val(i) = -1
next
for i = 48 to 57
    val(i) = i - 48
next
for i = 65 to 90
    val(i) = i - 55
next
val(45) = 36
val(46) = 37
val(32) = 38
val(36) = 39
val(47) = 40
val(43) = 41
val(37) = 42
valid = false
message = ""
prev = ""
l = 1
while l > 0
    message = getmsg
    if message > "" then
        convmess = convert
        message = inputbox("Copy the text below, and paste it into your" _
            & " application." & vbNewLine & vbNewLine _
            & "You may then enter a new message for another conversion.", _
            banner, convmess)
        valid = false
        l = len(message)
    end if
wend

function getmsg
    while not valid
        if message = "" then
            message = inputbox(msgtext, banner, prev)
        end if
        chars = mysplit(message)
        l = len(message)
        if l > 0 then
            valid = true
            for i = 1 to l
                if val(asc(chars(i))) < 0 then
                    valid = false
                    char = chars(i)
                    exit for
                end if
            next
            if not valid then
                MsgBox "Invalid character: " & char, vbCritical, "Error"
                prev = message
                message = ""
            end if
        else
            valid = true
        end if
    wend
    getmsg = message
end function

function convert
    check = 0
    for i = 1 to l
        check = check + val(asc(chars(i)))
    next
    check = check mod 43
    for i = 0 to 255
        if check = val(i) then
            ch = chr(i)
        end if
    next
    convert = "*" & join(chars, "") & ch & "*"
end function

function mysplit(text)
    dim myarray()
    redim myarray(len(text))
    for i = 1 to len(text)
        myarray(i) = mid(text, i, 1)
    next
    mysplit = myarray
end function
